//
// Program: Perception RPC client demo program
// Author: Jos van Damme
// (c) 2009, HBM
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PnrfReader
{
     public partial class XYGraphProperties : Form
     {
          private XYGraphControl m_XYGraphControl;

          public XYGraphProperties()
          {
               InitializeComponent();
               comboBoxPoints.SelectedIndex = 0;
          }

          public XYGraphControl XYGraphControl
          {
               set
               {
                    m_XYGraphControl = value;
                    UpdateDialog();
               }
               get
               {
                    return m_XYGraphControl;
               }
          }

          private void UpdateDialog()
          {
               edtOriginX.Text = m_XYGraphControl.XOrigin.ToString();
               edtXaxisLabel.Text = m_XYGraphControl.LabelX;
               edtTickValueX.Text = m_XYGraphControl.XTickValue.ToString();

               edtOriginY.Text = m_XYGraphControl.YOrigin.ToString();
               edtYaxisLabel.Text = m_XYGraphControl.LabelY;
               edtTickValueY.Text = m_XYGraphControl.YTickValue.ToString();

               switch (m_XYGraphControl.DotShape)
               {
                    case XYGraphControl.dotShape.Plus:
                         {
                              comboBoxPoints.SelectedIndex = 1;
                         }
                         break;
                    case XYGraphControl.dotShape.Cross:
                         {
                              comboBoxPoints.SelectedIndex = 2;
                         }
                         break;
                    case XYGraphControl.dotShape.BigPlus:
                         {
                              comboBoxPoints.SelectedIndex = 3;
                         }
                         break;
                    default:
                         {
                              comboBoxPoints.SelectedIndex = 0;
                         }
                         break;
               }
               chkConnectPoints.Checked = m_XYGraphControl.ConnectPointsFlag;
          }

          private void ApplyToXYGraph()
          {
               try
               {
                    m_XYGraphControl.XOrigin = (float)Convert.ToDouble(edtOriginX.Text);
               }
               catch
               {
               }

               m_XYGraphControl.LabelX = edtXaxisLabel.Text;

               try
               {
                    m_XYGraphControl.XTickValue = (float)Convert.ToDouble(edtTickValueX.Text);
               }
               catch
               {
               }

               try
               {
                    m_XYGraphControl.YOrigin = (float)Convert.ToDouble(edtOriginY.Text);
               }
               catch
               {
               }

               m_XYGraphControl.LabelY = edtYaxisLabel.Text;

               try
               {
                    m_XYGraphControl.YTickValue = (float)Convert.ToDouble(edtTickValueY.Text);
               }
               catch
               {
               }

               m_XYGraphControl.ConnectPointsFlag = chkConnectPoints.Checked;

               switch (comboBoxPoints.SelectedIndex)
               {
                    case 1:
                         {
                              m_XYGraphControl.DotShape = XYGraphControl.dotShape.Plus;
                         }
                         break;

                    case 2:
                         {
                              m_XYGraphControl.DotShape = XYGraphControl.dotShape.Cross;
                         }
                         break;
                    case 3:
                         {
                              m_XYGraphControl.DotShape = XYGraphControl.dotShape.BigPlus;
                         }
                         break;
                    default:
                         {
                              m_XYGraphControl.DotShape = XYGraphControl.dotShape.Dot;
                         }
                         break;

               }
               m_XYGraphControl.Invalidate();
               m_XYGraphControl.RefreshDrawing();

          }

          private void btnApply_Click(object sender, EventArgs e)
          {
               ApplyToXYGraph();
               UpdateDialog();
          }

          private void btnOK_Click(object sender, EventArgs e)
          {
               ApplyToXYGraph();
               Close();
          }
     }
}